/* Socks Server 5
 * Copyright (C) 2002 - 2006 by Matteo Ricchetti - <matteo.ricchetti@libero.it>

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include"SS5Main.h"
#include"SS5Mod_statistics.h"


S5RetCode InitModule( struct _module *m )
{
  m->Statistics = Statistics;
  m->Summary = Summary;

  return OK;
}


S5RetCode Statistics( struct _SS5ClientInfo *ci, struct _SS5Socks5Data *sd )
{
  time_t currentAge;

  char *httpResponse;

  if( STREQ(sd->MethodRequest,"GET /statistics HTTP/1.",sizeof("GET /statistics HTTP/1.") - 1) 
      || STREQ(sd->MethodRequest,"GET /statistics/ HTTP/1.",sizeof("GET /statistics/ HTTP/1.") - 1) ) {
    /*
     *    Create http response
     */
    httpResponse = (char *)calloc((1024*22),sizeof(char));

    currentAge = time(NULL);

    snprintf(httpResponse,(1024*22),
"HTTP/1.1 200 OK\r\n\
Server: Socks Server 5-V3.2\r\n\
Connection: close\r\n\
Content-Type: text/html; charset=ISO-8859-1\r\n\
Content-Language: en\r\n\r\n\
<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"> \
<html> \
<head> \
  <meta content=\"text/html; charset=ISO-8859-1\" \
 http-equiv=\"content-type\"> \
  <meta http-equiv=\"refresh\" content=\"60\"> \
  <title>SS5V3</title> \
</head> \
<body> \
<table style=\"width: 100%%; text-align: left;\" cellpadding=\"0\" \
 cellspacing=\"0\"> \
  <tbody> \
    <tr> \
      <td style=\"width: 100px; vertical-align: top;\"><img alt=\"\" \
 src=\"SS5Logo.jpg\" \
 style=\"height: 79px; width: 106px;\"><br> \
      </td> \
      <td style=\"vertical-align: top; text-align: right;\"><a \
 style=\"font-weight: bold; font-family: tahoma;\" href=\"http://ss5.sourceforge.net/\"><font \
 size=\"-1\"></font></a><a href=\"http://ss5.sourceforge.net/\"><font size=\"-1\"><span \
 style=\"font-family: tahoma;\">SS5 Home Page</span></font></a> <br> \
      <br> \
      <hr style=\"width: 100%%; height: 2px;\"><br> \
      </td> \
    </tr> \
  </tbody> \
</table> \
<br> \
<table \
 style=\"background-color: rgb(85, 111, 147); width: 100%%; text-align: left;\" \
 cellpadding=\"2\"> \
  <tbody> \
    <tr> \
      <td style=\"vertical-align: top;\"><font \
 style=\"color: rgb(255, 255, 255);\" size=\"-1\"><span \
 style=\"font-family: tahoma; font-weight: bold;\">SS5 Socks Server 5 \
Console</span></font><br> \
      </td> \
    </tr> \
  </tbody> \
</table> \
<table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 cellpadding=\"2\"> \
  <tbody> \
    <tr> \
      <td style=\"vertical-align: top;\"><font \
 style=\"font-weight: bold; font-family: tahoma;\" size=\"-2\">Date \
%s</font><br> \
      </td> \
      <td style=\"vertical-align: top; text-align: right;\"><font \
 size=\"-1\"><span style=\"font-family: tahoma;\">Join to SS5 </span><a \
 style=\"font-family: tahoma;\" \
 href=\"http://lists.penguin.it/mailman/listinfo/ss5\">Mailinglist</a></font><br> \
      </td> \
    </tr> \
  </tbody> \
</table> \
<br> \
<table style=\"text-align: left; width: 987px; height: 141px;\" \
 cellpadding=\"2\"> \
  <tbody> \
    <tr> \
      <td \
 style=\"height: 25px; background-color: rgb(173, 207, 206); vertical-align: top;\"><font \
 size=\"-1\"><span style=\"font-family: tahoma; font-weight: bold;\">Command \
(cumulative \
values)</span></font><br> \
      </td> \
      <td \
 style=\"background-color: rgb(173, 207, 206); vertical-align: top;\"><br> \
      </td> \
      <td \
 style=\"background-color: rgb(173, 207, 206); vertical-align: top;\"><font \
 size=\"-1\"><span style=\"font-family: tahoma; font-weight: bold;\">Command \
(current \
values)</span></font></td> \
      <td \
 style=\"background-color: rgb(173, 207, 206); vertical-align: top;\"><br> \
      </td> \
    </tr> \
    <tr style=\"font-family: tahoma;\" align=\"left\"> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">V4<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Connect<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Bind<br> \
            </font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Normal<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Failed<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">V5<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Connect<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Bind<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Udp<br> \
            </font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Normal<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Failed<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">V4<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Connect<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Bind<br> \
            </font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">%lu</font></td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">V5<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Connect<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Bind<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Udp<br> \
            </font></td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top; font-family: tahoma;\"><font \
 size=\"-1\">%lu</font></td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
    </tr> \
  </tbody> \
</table> \
<br> \
<table style=\"text-align: left; width: 987px; height: 148px;\" \
 cellpadding=\"2\"> \
  <tbody> \
    <tr> \
      <td \
 style=\"height: 25px; background-color: rgb(173, 207, 206); vertical-align: top;\"><font \
 size=\"-1\"><span style=\"font-family: tahoma; font-weight: bold;\">Authentication/Authorization \
(cumulative \
values)</span></font><br> \
      </td> \
      <td \
 style=\"background-color: rgb(173, 207, 206); vertical-align: top;\"><font \
 size=\"-1\"><span style=\"font-family: tahoma; font-weight: bold;\">Authentication/Authorization \
(current \
values)</span></font></td> \
    </tr> \
    <tr style=\"font-family: tahoma;\" align=\"left\"> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\"><br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(File)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(EAP)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(PAM)<br> \
            </font> </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Author \
(File)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Author \
(Ldap)<br> \
            </font> </td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Normal<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Failed<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
      <td style=\"vertical-align: top;\"> \
      <table \
 style=\"background-color: rgb(220, 220, 220); width: 100%%; text-align: left;\" \
 border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \
        <tbody> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\"><br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(File)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(EAP)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Authen \
(PAM)<br> \
            </font> </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Author \
(File)<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Author \
(Ldap)<br> \
            </font> </td> \
          </tr> \
          <tr> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">Total<br> \
            </font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font></td> \
            <td style=\"vertical-align: top;\"><font size=\"-1\">%lu</font> \
            </td> \
          </tr> \
        </tbody> \
      </table> \
      </td> \
    </tr> \
  </tbody> \
</table> \
<br> \
</body> \
</html>",
    ctime(&currentAge),
    SS5Statistics.V4Total_Connect,SS5Statistics.V4Total_Bind, 
    SS5Statistics.V4Normal_Connect,SS5Statistics.V4Normal_Bind, 
    SS5Statistics.V4Failed_Connect,SS5Statistics.V4Failed_Bind, 
    
    SS5Statistics.V5Total_Connect,SS5Statistics.V5Total_Bind,SS5Statistics.V5Total_Udp, 
    SS5Statistics.V5Normal_Connect,SS5Statistics.V5Normal_Bind,SS5Statistics.V5Normal_Udp, 
    SS5Statistics.V5Failed_Connect,SS5Statistics.V5Failed_Bind,SS5Statistics.V5Failed_Udp, 
    
    SS5Statistics.V4Current_Connect,SS5Statistics.V4Current_Bind, 
    SS5Statistics.V5Current_Connect,SS5Statistics.V5Current_Bind,SS5Statistics.V5Current_Udp, 
    
    SS5Statistics.Total_Auth_File,SS5Statistics.Total_Auth_EAP,SS5Statistics.Total_Auth_PAM,SS5Statistics.Total_Author_File,SS5Statistics.Total_Author_Ldap, 
    SS5Statistics.Normal_Auth_File,SS5Statistics.Normal_Auth_EAP,SS5Statistics.Normal_Auth_PAM,SS5Statistics.Normal_Author_File,SS5Statistics.Normal_Author_Ldap, 
    SS5Statistics.Failed_Auth_File,SS5Statistics.Failed_Auth_EAP,SS5Statistics.Failed_Auth_PAM,SS5Statistics.Failed_Author_File,SS5Statistics.Failed_Author_Ldap, 

    SS5Statistics.Current_Auth_File,SS5Statistics.Current_Auth_EAP,SS5Statistics.Current_Auth_PAM,SS5Statistics.Current_Author_File,SS5Statistics.Current_Author_Ldap
);
    

    /*
     *    Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 

      return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /SS5Logo.jpg HTTP/1.",sizeof("GET /SS5Logo.jpg HTTP/1.") - 1) || 
           STREQ(sd->MethodRequest,"GET /statistics/SS5Logo.jpg HTTP/1.",sizeof("GET /statistics/SS5Logo.jpg HTTP/1.") - 1) ) {
    /*
     *    Create http response
     */
    httpResponse = (char *)calloc(256,sizeof(char));


    snprintf(httpResponse,255,
"HTTP/1.1 200 OK\r\n\
Server: Socks Server 5-V3.2\r\n\
Connection: close\r\n\
Content-Type: image/jpg\r\n\r\n");

    /*
     *    Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      send(ci->Socket,S5LogoBuffer,65536,SS5_SEND_OPT);
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 

      return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /counter=CONNECT HTTP/1.",sizeof("GET /counter=CONNECT HTTP/1.") - 1) ) {
    /*
     *    Create http response
     */
    httpResponse=(char *)calloc((128),sizeof(char));

    snprintf(httpResponse,sizeof(httpResponse) - 1,"%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n",SS5Statistics.V5Total_Connect,
                                                           SS5Statistics.V4Total_Connect,
                                                           SS5Statistics.V5Normal_Connect,
                                                           SS5Statistics.V4Normal_Connect,
                                                           SS5Statistics.V5Failed_Connect,
                                                           SS5Statistics.V4Failed_Connect,
                                                           SS5Statistics.V5Current_Connect,
                                                           SS5Statistics.V4Current_Connect);

    /*
     *    Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 
    return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /counter=BIND HTTP/1.",sizeof("GET /counter=BIND HTTP/1.") - 1) ) {
    /*
     * Create http response
     */
    httpResponse=(char *)calloc((128),sizeof(char));

    snprintf(httpResponse,sizeof(httpResponse) - 1,"%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n",SS5Statistics.V5Total_Bind,
                                                           SS5Statistics.V4Total_Bind,
                                                           SS5Statistics.V5Normal_Bind,
                                                           SS5Statistics.V4Normal_Bind,
                                                           SS5Statistics.V5Failed_Bind,
                                                           SS5Statistics.V4Failed_Bind,
                                                           SS5Statistics.V5Current_Bind,
                                                           SS5Statistics.V4Current_Bind);

    /*
     * Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 
    return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /counter=UDP HTTP/1.",sizeof("GET /counter=UDP HTTP/1.") - 1) ) {
    /*
     * Create http response
     */
    httpResponse=(char *)calloc((128),sizeof(char));

    snprintf(httpResponse,sizeof(httpResponse) - 1,"%lu\n%lu\n%lu\n%lu\n",SS5Statistics.V5Total_Udp,
                                                           SS5Statistics.V5Normal_Udp,
                                                           SS5Statistics.V5Failed_Udp,
                                                           SS5Statistics.V5Current_Udp);

    /*
     * Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 
    return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /counter=AUTHEN HTTP/1.",sizeof("GET /counter=AUTHEN HTTP/1.") - 1) ) {
    /*
     * Create http response
     */
    httpResponse=(char *)calloc((256),sizeof(char));

    snprintf(httpResponse,256 - 1,"%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n",
                                                           SS5Statistics.Total_Auth_File,
                                                           SS5Statistics.Total_Auth_EAP,
                                                           SS5Statistics.Total_Auth_PAM,
                                                           SS5Statistics.Normal_Auth_File,
                                                           SS5Statistics.Normal_Auth_EAP,
                                                           SS5Statistics.Normal_Auth_PAM,
                                                           SS5Statistics.Failed_Auth_File,
                                                           SS5Statistics.Failed_Auth_EAP,
                                                           SS5Statistics.Failed_Auth_PAM,
                                                           SS5Statistics.Current_Auth_File,
                                                           SS5Statistics.Current_Auth_EAP,
                                                           SS5Statistics.Current_Auth_PAM);

    /*
     * Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 
    return OK;
    }
  }
  else if( STREQ(sd->MethodRequest,"GET /counter=AUTHOR HTTP/1.",sizeof("GET /counter=AUTHOR HTTP/1.") - 1) ) {
    /*
     * Create http response
     */
    httpResponse=(char *)calloc((128),sizeof(char));

    snprintf(httpResponse,sizeof(httpResponse) - 1,"%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n%lu\n",
                                                           SS5Statistics.Total_Author_File,
                                                           SS5Statistics.Total_Author_Ldap,
                                                           SS5Statistics.Normal_Author_File,
                                                           SS5Statistics.Normal_Author_Ldap,
                                                           SS5Statistics.Failed_Author_File,
                                                           SS5Statistics.Failed_Author_Ldap,
                                                           SS5Statistics.Current_Author_File,
                                                           SS5Statistics.Current_Author_Ldap);

    /*
     * Send http response
     */
    if( send(ci->Socket,httpResponse,strlen(httpResponse),SS5_SEND_OPT) == -1) {
      free(httpResponse); 
      return ERR;
    }
    else {
      fcntl(ci->Socket,F_SETFL,O_NONBLOCK);
      recv(ci->Socket,httpResponse,strlen(httpResponse),0);
      free(httpResponse); 
    return OK;
    }
  }

  return ERR;
}

S5RetCode Summary( unsigned int autheerr, unsigned int authoerr, unsigned int cmderr )
{
  /*
  * Using threaded mode, ss5 updates socks requests statistics
  */
  if( THREADED() ) {
    switch( autheerr ) {
      case AFN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_File++;   SS5Statistics.Normal_Auth_File++;
        if( SS5Statistics.Current_Auth_File )
          SS5Statistics.Current_Auth_File--;
        pthread_mutex_unlock( &CSMutex );    break;
      case AFF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_File++;   SS5Statistics.Failed_Auth_File++;
        if( SS5Statistics.Current_Auth_File )
          SS5Statistics.Current_Auth_File--;
        pthread_mutex_unlock( &CSMutex );    break;
      case AEN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_EAP++;    SS5Statistics.Normal_Auth_EAP++;
        if( SS5Statistics.Current_Auth_EAP )
          SS5Statistics.Current_Auth_EAP--;
        pthread_mutex_unlock( &CSMutex );    break;
      case AEF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_EAP++;    SS5Statistics.Failed_Auth_EAP++;
        if( SS5Statistics.Current_Auth_EAP )
          SS5Statistics.Current_Auth_EAP--;
        pthread_mutex_unlock( &CSMutex );    break;
      case APN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_PAM++;    SS5Statistics.Normal_Auth_PAM++;
        if( SS5Statistics.Current_Auth_PAM )
          SS5Statistics.Current_Auth_PAM--;
        pthread_mutex_unlock( &CSMutex );    break;
      case APF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Auth_PAM++;    SS5Statistics.Failed_Auth_PAM++;
        if( SS5Statistics.Current_Auth_PAM )
          SS5Statistics.Current_Auth_PAM--;
        pthread_mutex_unlock( &CSMutex );    break;
    }

    switch( authoerr ) {
      case HFN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Author_File++;    SS5Statistics.Normal_Author_File++;
        if( SS5Statistics.Current_Author_File )
          SS5Statistics.Current_Author_File--;
        pthread_mutex_unlock( &CSMutex );    break;
      case HFF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Author_File++;    SS5Statistics.Failed_Author_File++;
        if( SS5Statistics.Current_Author_File )
          SS5Statistics.Current_Author_File--;
        pthread_mutex_unlock( &CSMutex );    break;
      case HLN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Author_Ldap++;    SS5Statistics.Normal_Author_Ldap++;
        if( SS5Statistics.Current_Author_Ldap )
          SS5Statistics.Current_Author_Ldap--;
        pthread_mutex_unlock( &CSMutex );    break;
      case HLF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.Total_Author_Ldap++;    SS5Statistics.Failed_Author_Ldap++;
        if( SS5Statistics.Current_Author_Ldap )
          SS5Statistics.Current_Author_Ldap--;
        pthread_mutex_unlock( &CSMutex );    break;
    }

    switch( cmderr ) {
      case V4CN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V4Total_Connect++;    SS5Statistics.V4Normal_Connect++;
        if( SS5Statistics.V4Current_Connect )
          SS5Statistics.V4Current_Connect--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V4CF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V4Total_Connect++;    SS5Statistics.V4Failed_Connect++;
        if( SS5Statistics.V4Current_Connect )
          SS5Statistics.V4Current_Connect--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V4BN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V4Total_Bind++;       SS5Statistics.V4Normal_Bind++;
        if( SS5Statistics.V4Current_Bind )
          SS5Statistics.V4Current_Bind--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V4BF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V4Total_Bind++;       SS5Statistics.V4Failed_Bind++;
        if( SS5Statistics.V4Current_Bind )
          SS5Statistics.V4Current_Bind--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5CN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Connect++;    SS5Statistics.V5Normal_Connect++;
        if( SS5Statistics.V5Current_Connect )
          SS5Statistics.V5Current_Connect--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5CF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Connect++;    SS5Statistics.V5Failed_Connect++;
        if( SS5Statistics.V5Current_Connect )
          SS5Statistics.V5Current_Connect--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5BN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Bind++;       SS5Statistics.V5Normal_Bind++;
        if( SS5Statistics.V5Current_Bind )
          SS5Statistics.V5Current_Bind--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5BF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Bind++;       SS5Statistics.V5Failed_Bind++;
        if( SS5Statistics.V5Current_Bind )
          SS5Statistics.V5Current_Bind--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5UN:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Udp++;        SS5Statistics.V5Normal_Udp++;
        if( SS5Statistics.V5Current_Udp )
          SS5Statistics.V5Current_Udp--;
        pthread_mutex_unlock( &CSMutex );    break;
      case V5UF:    pthread_mutex_lock( &CSMutex );    SS5Statistics.V5Total_Udp++;        SS5Statistics.V5Failed_Udp++;
        if( SS5Statistics.V5Current_Udp )
          SS5Statistics.V5Current_Udp--;
        pthread_mutex_unlock( &CSMutex );    break;
    }
  }

  return OK;
}
